/*
	Name:			XenoN PlayGate Plugin
	Version:		1.0.0.0
	Update:			2009-10-04
	Copyright:		Copyright  2007-2009 XenoN PlayGate by PsichiX. All rights reserved.
	Author:			PsichiX
	Website:		http://www.playgate.psichix.com
	Description:	XenoN PlayGate GameMaker Plugin
*/

#define PG_PLUGIN
#define XE_COMPILE_PHOTON
#define XE_COMPILE_CHAOS
#include "XenoN PlayGate.h"

PLAYGATE PlayGate;

bool Startup()
{
	if(PlayGate.System(SET,XE_SCENE_COLOR,(XE_NUMBER)0,(XE_NUMBER)0.5,(XE_NUMBER)1,(XE_NUMBER)1))
	if(PlayGate.Photon(UPDATE,XE_FLAG_COLORBUFF))
	{
		PlayGate.Photon(VSYNC,XE_TRUE);
		MessageBox(NULL,"Successful!","test",MB_OK);
		return(true);
	}
	MessageBox(NULL,"Failed!","test",MB_OK);
	return(false);
}

PG_FARPROC GM_REAL DrawRect(GM_REAL x,GM_REAL y,GM_REAL w,GM_REAL h)
{
	PlayGate.System(SET,XE_RENDER_TEXTURING_2D,XE_FALSE);
	PlayGate.Photon(PRIMITIVE_BEGIN,XE_QUADS);
	PlayGate.Photon(PUT,VERTEX,x,y,(XE_NUMBER)0,(XE_NUMBER)1);
	PlayGate.Photon(PUT,VERTEX,x+w,y,(XE_NUMBER)0,(XE_NUMBER)1);
	PlayGate.Photon(PUT,VERTEX,x+w,y+h,(XE_NUMBER)0,(XE_NUMBER)1);
	PlayGate.Photon(PUT,VERTEX,x,y+h,(XE_NUMBER)0,(XE_NUMBER)1);
	PlayGate.Photon(PRIMITIVE_END);
	PlayGate.System(SET,XE_RENDER_TEXTURING_2D,XE_TRUE);
	return(XE_TRUE);
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		Startup();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	}
	return XE_TRUE;
}

#undef PG_PLUGIN